#ifndef TILES_RENDER_FRAME_H
#define TILES_RENDER_FRAME_H
  
// Delay: 1 cycle
#define NOP __asm __volatile ("nop")

// Delay: decimal us
#define DELAY_07  __asm __volatile ("nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t") // 11.2 - 1 ~ 10
#define DELAY_03  __asm __volatile ("nop\n\t""nop\n\t""nop\n\t""nop\n\t") // 4.8 - 1 ~ 4
#define DELAY_035 __asm __volatile ("nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t") // 5.6 - 1 ~ 5
#define DELAY_065 __asm __volatile ("nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t") // 10.4 - 1 ~ 9

// Sync signals
inline void BoardSync()
{
  PORT = _SYNC; // 27.3
  delayMicroseconds(27); DELAY_03;
  PORT = _VSYNC; // 4.7
  delayMicroseconds(4); DELAY_07;
  // 512 cliclos
}

inline void ShortSync()
{
  PORT = _SYNC; // 2.35
  delayMicroseconds(2); DELAY_035;
  PORT = _VSYNC; // 29.65
  delayMicroseconds(29); DELAY_065;
  // 512 cliclos
}

inline void HSync()
{
  PORT = _SYNC; // 4.7
  delayMicroseconds(4); DELAY_07;
  PORT = _HSYNC; // 5.7
  delayMicroseconds(5); DELAY_07;
  // 166 cliclos
}

inline void FrontPorch()
{
  PORT = _HSYNC; // 1.65
  delayMicroseconds(1); DELAY_065;
  // 26 cliclos
}

unsigned int line;
unsigned int cLine;
byte nLine;

// Render a frame
// Pseudo-progressive PAL: 312 lines
void Render()
{

  for (line=0;line<DISPLAY_LINES; line++)
  {    
   
    switch(line)
    {
     
      case   0 ...   1:
        BoardSync();
        BoardSync();
        break;
 
      case 2:
        BoardSync();
        ShortSync();
        break;
 
      case   3 ...   4:
      case 310 ... 311:
        ShortSync();
        ShortSync();
        break;
        
      case 309:
        HSync();
        delayMicroseconds(21); DELAY_07;
        ShortSync();
        break;

      case   5 ...  22:
        cLine = 0;
        HSync();
        delayMicroseconds(52);
        FrontPorch();
        break;

      default:
        nLine = (cLine++)>>1;
        HSync();
        //RenderLine(bitmap[nLine]); // PROGMEM Render
        RenderSRAM(sram[nLine]);     // SRAM Render
        FrontPorch();
        break;
 
      }

   }

}

#endif
