#ifndef TILES_SRAM_BUFFER_H
#define TILES_SRAM_BUFFER_H

byte *sram[BUFFER_W];

void InitSRAM()
{

  // Enable MegaRAM shield external memory
  XMCRA = _BV(SRE);

  // Disable high memory masking (don't need >56kbytes in this app)
  XMCRB = 0;

  // Enable RAM device
  pinMode(42, OUTPUT); digitalWrite(42, HIGH);

  // Enable bank select output and select bank 0. Don't need dual banks in this app.
  pinMode(38, OUTPUT); digitalWrite(38, LOW);
  
  // Alloc buffer
  for(unsigned int y=0; y<BUFFER_H; y++ )
    sram[y] = (byte *) 0x2200U + (y * BUFFER_W);

}

void SetTile(byte x, byte y, byte tile)
{
  y *= TILE_SIZE;
  x *= TILE_SIZE;
  for(byte ty=0; ty<TILE_SIZE; ty++)
    memcpy_P(&sram[y+ty][x], &TileSet[tile][ty], TILE_SIZE);
}

void SetTile(byte x, byte y)
{
  byte tile = TileMap[y][x];
  SetTile(x, y, tile);
}

void FillSRAM()
{
  for(byte y=0; y<BUFFER_H/8; y++)
    for(byte x=0; x<BUFFER_W/8; x++)
      SetTile(x, y);
}

#endif
